diff --git a/main-bisect.sh b/main-bisect.sh
new file mode 100755
index 0000000000000000000000000000000000000000..c92ab4a6df85893895d74f35e7fd68246e022121_bWFpbi1iaXNlY3Quc2g=
--- /dev/null
+++ b/main-bisect.sh
@@ -0,0 +1,18 @@
+#!/bin/bash
+#
+# Script used on the main performance benchmark machine to run tests.
+set -eox pipefail
+
+ROOT=`dirname $0`
+
+# source "${ROOT}"/../virtualenv/bin/activate
+rm -rf "${ROOT}"/env/
+
+./run-scripts/before-check.sh
+
+time HGRCPATH= taskset -c 2,3 asv find --save_results $@
+
+# Publish results
+asv publish --no-pull
+
+netlify deploy
diff --git a/scheduler.py b/scheduler.py
index 8ce5b7ec930176e9f199178814137aac97b3886b_c2NoZWR1bGVyLnB5..c92ab4a6df85893895d74f35e7fd68246e022121_c2NoZWR1bGVyLnB5 100644
--- a/scheduler.py
+++ b/scheduler.py
@@ -28,6 +28,9 @@
 
 RUN_SCRIPT = os.environ.get("SCHEDULER_TEST_RUN_SCRIPT", DEFAULT_RUN_SCRIPT)
 
+DEFAULT_BISECT_SCRIPT = abspath(join(dirname(__file__), "main-bisect.sh"))
+
+BISECT_SCRIPT = os.environ.get("SCHEDULER_TEST_BISECT_SCRIPT", DEFAULT_BISECT_SCRIPT)
 
 LOGGER = logging.getLogger(__name__)
 LOG_FORMAT = "[%(asctime)s] %(message)s"
@@ -53,6 +56,19 @@
         print("\n" + msg % (task, e.returncode))
         # XXX find a way to report an error without removing a task
 
+def bisect(task):
+    splitted = shlex.split(task)
+    args = [BISECT_SCRIPT] + splitted
+
+    try:
+        print("Bisecting %r" % args)
+        subprocess.check_call(args)
+    except subprocess.CalledProcessError as e:
+        msg = "Task %r failed with error code %r"
+        LOGGER.error(msg, task, e.returncode)
+        print("\n" + msg % (task, e.returncode))
+        # XXX find a way to report an error without removing a task
+
 
 def remove_task(task, task_file_path):
     """ Remove the first line of the scheduling TASK if it match passed task
@@ -94,6 +110,8 @@
             try:
                 if task_type == "RUN":
                     run(task_arguments)
+                elif task_type == "BISECT":
+                    bisect(task_arguments)
                 elif task_type == "EXIT":
                     return
                 else:
diff --git a/tests/scripts/scheduler-test-bisect-script-success b/tests/scripts/scheduler-test-bisect-script-success
new file mode 100755
index 0000000000000000000000000000000000000000..c92ab4a6df85893895d74f35e7fd68246e022121_dGVzdHMvc2NyaXB0cy9zY2hlZHVsZXItdGVzdC1iaXNlY3Qtc2NyaXB0LXN1Y2Nlc3M=
--- /dev/null
+++ b/tests/scripts/scheduler-test-bisect-script-success
@@ -0,0 +1,6 @@
+#!/bin/bash
+set -eo pipefail
+
+echo "Bisecting test script $@"
+
+exit 0
diff --git a/tests/scheduler-test-script-success b/tests/scripts/scheduler-test-script-success
similarity index 70%
rename from tests/scheduler-test-script-success
rename to tests/scripts/scheduler-test-script-success
index 8ce5b7ec930176e9f199178814137aac97b3886b_dGVzdHMvc2NoZWR1bGVyLXRlc3Qtc2NyaXB0LXN1Y2Nlc3M=..c92ab4a6df85893895d74f35e7fd68246e022121_dGVzdHMvc2NyaXB0cy9zY2hlZHVsZXItdGVzdC1zY3JpcHQtc3VjY2Vzcw== 100755
--- a/tests/scheduler-test-script-success
+++ b/tests/scripts/scheduler-test-script-success
@@ -1,4 +1,6 @@
 #!/bin/bash
 set -eo pipefail
 
+echo "Running test script $@"
+
 exit 0
diff --git a/tests/test-scheduler.t b/tests/test-scheduler.t
index 8ce5b7ec930176e9f199178814137aac97b3886b_dGVzdHMvdGVzdC1zY2hlZHVsZXIudA==..c92ab4a6df85893895d74f35e7fd68246e022121_dGVzdHMvdGVzdC1zY2hlZHVsZXIudA== 100644
--- a/tests/test-scheduler.t
+++ b/tests/test-scheduler.t
@@ -1,6 +1,7 @@
 Test the scheduler
 
-  $ export SCHEDULER_TEST_RUN_SCRIPT=$TESTDIR/scheduler-test-script-success
+  $ export SCHEDULER_TEST_RUN_SCRIPT=$TESTDIR/scripts/scheduler-test-script-success
+  $ export SCHEDULER_TEST_BISECT_SCRIPT=$TESTDIR/scripts/scheduler-test-bisect-script-success
 
   $ cat << EOF >> TASKS
   > RUN tip
@@ -8,6 +9,7 @@
   > EOF
 
   $ python $TESTDIR/../scheduler.py TASKS
+  Running test script tip
   ================================================================================
   Got task 'RUN' 'tip'
   RUNNING ['*/scheduler-test-script-success', 'tip'] (glob)
@@ -40,6 +42,7 @@
   > EOF
 
   $ python $TESTDIR/../scheduler.py --log LOG TASKS
+  Running test script tip
   ================================================================================
   Got task 'RUN' 'tip'
   RUNNING ['*/scheduler-test-script-success', 'tip'] (glob)
@@ -72,5 +75,6 @@
   > EOF
 
   $ python $TESTDIR/../scheduler.py TASKS
+  Bisecting test script tip..tip~2 track_startup
   ================================================================================
   Got task 'BISECT' 'tip..tip~2 track_startup'
@@ -75,6 +79,6 @@
   ================================================================================
   Got task 'BISECT' 'tip..tip~2 track_startup'
-  Unknown task BISECT
+  Bisecting ['*/scripts/scheduler-test-bisect-script-success', 'tip..tip~2', 'track_startup'] (glob)